﻿Imports Syncfusion.PivotAnalysis.Base
Imports Syncfusion.Windows.Forms.Grid
Imports System.Reflection
Imports System.Windows.Forms


Public Class Form1
    Private Sub OrdersBindingNavigatorSaveItem_Click(sender As Object, e As EventArgs) Handles OrdersBindingNavigatorSaveItem.Click
        Me.Validate()
        Me.OrdersBindingSource.EndEdit()
        Me.TableAdapterManager.UpdateAll(Me.NORTHWNDDataSet)

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'NORTHWNDDataSet.Orders' table. You can move, or remove it, as needed.
        Me.OrdersTableAdapter.Fill(Me.NORTHWNDDataSet.Orders)
        Me.PivotGridControl1.ItemSource = Me.OrdersBindingSource
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "ShipName", .FieldHeader = "Name", .TotalHeader = "Total", .AllowFilter = True, .AllowSort = True})
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "OrderID", .FieldHeader = "Order", .TotalHeader = "Total", .AllowFilter = True, .AllowSort = True})
        PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "ShipRegion", .TotalHeader = "Total"})
        PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "ShipCity", .TotalHeader = "Total"})
        PivotGridControl1.PivotRows.Add(New PivotItem With {.FieldMappingName = "ShipCountry", .TotalHeader = "Total"})
        ' PivotGridControl1.PivotColumns.Add(New PivotItem With {.FieldMappingName = "EmployeeID", .TotalHeader = "Total"})
        PivotGridControl1.PivotCalculations.Add(New PivotComputationInfo With {.FieldName = "Freight", .Format = "#, ##0", .SummaryType = SummaryType.Count})

        Me.PivotGridControl1.ShowPivotTableFieldList = True
        Me.PivotGridControl1.ShowGroupBar = True
        Me.PivotGridControl1.EnableValueEditing = True
        'Me.PivotGridControl1.TableControl.AllowColumnResizeUsingCellBoundaries = True

        'to hide the second column.
        PivotGridControl1.TableModel.ColWidths(2) = 0

        'AddHandler PivotGridControl1.TableControl.GroupDropArea.ColWidthsChanged, AddressOf GroupDropArea_ColWidthsChanged
        AddHandler Me.PivotGridControl1.TableModel.ColWidthsChanged, AddressOf TableModel_ColWidthsChanged

        'Resize the elements in row grouping bar.
        Dim emptySpaceWidth As Integer = 6
        Dim index As Integer
        For j As Integer = 1 To 2 * (PivotGridControl1.TableControl.PivotRows.Count)
            If j Mod 2 = 0 AndAlso PivotGridControl1.TableControl.RowGroupDropArea IsNot Nothing AndAlso PivotGridControl1.TableControl.RowGroupDropArea.Model IsNot Nothing Then
                index = j / 2
                PivotGridControl1.TableControl.RowGroupDropArea.Model.ColWidths(j) = If(PivotGridControl1.TableModel.ColWidths(index) = 0, 0, PivotGridControl1.TableModel.ColWidths(index) - (emptySpaceWidth + emptySpaceWidth / 2))
            End If
        Next

        'Me.GroupBarItems()

        'Resize the entire row group bar width.
        Dim width As Integer = 0
        For i As Integer = 0 To PivotGridControl1.PivotRows.Count - 1
            width += PivotGridControl1.TableModel.ColWidths(i)
        Next
        PivotGridControl1.TableControl.RowGroupDropArea.Width = width

    End Sub

    Private topLeftCellWidth As Integer
    Private maxRange, meanRange, colRange As Integer
    Private ColCount As Integer = 20
    Private RowCount As Integer = 3
    Private cellMinSize As Integer = 40, cellMaxSize As Integer = 70
    Private emptySpaceWidth As Integer = 6

    'To align the group bar items.
    Private Sub GroupBarItems()

        Dim width As Integer = 0
        Dim cellSize As Integer = 0

        Dim cal As Integer = 2 * PivotGridControl1.TableControl.PivotCalculations.Count
        maxRange = If(PivotGridControl1.TableControl.PivotCalculations.Count > 0, cal, 2)
        meanRange = maxRange + 1
        Dim col As Integer = 2 * PivotGridControl1.TableControl.PivotColumns.Count
        colRange = maxRange + col
        Dim itemCount As Integer = maxRange / 2
        Dim proposedWidth As Integer = (itemCount * cellMaxSize) + (itemCount * emptySpaceWidth)

        For i As Integer = 0 To PivotGridControl1.PivotRows.Count - 1
            Width += PivotGridControl1.TableModel.ColWidths(i)
        Next

        PivotGridControl1.TableControl.RowGroupDropArea.Width = Width
        topLeftCellWidth = Width

        If proposedWidth < topLeftCellWidth Then
            cellSize = cellMaxSize
        Else
            cellSize = cellMinSize
        End If

        For i As Integer = 1 To PivotGridControl1.TableModel.ColCount - 1

            If i < meanRange Then

                If i Mod 2 <> 0 Then
                    PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = emptySpaceWidth
                Else

                    If PivotGridControl1.TableControl.PivotCalculations.Count >= 1 OrElse PivotGridControl1.TableControl.PivotRows.Count = 0 Then
                        PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = cellSize
                    Else
                        PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = PivotGridControl1.TableControl.DefaultColWidth
                    End If
                End If
            ElseIf i > meanRange Then

                If i Mod 2 <> 0 Then
                    PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = emptySpaceWidth
                ElseIf PivotGridControl1.TableModel.ColWidths(i) <> emptySpaceWidth Then
                    PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = PivotGridControl1.TableControl.DefaultColWidth
                End If
            ElseIf i = meanRange Then

                If PivotGridControl1.TableControl.PivotRows.Count > 0 Then
                    Dim prevItemsWidth = 0

                    For j As Integer = 1 To meanRange - 1
                        prevItemsWidth += PivotGridControl1.TableControl.GroupDropArea.ColWidths(j)
                    Next

                    PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = topLeftCellWidth - prevItemsWidth + emptySpaceWidth
                Else
                    PivotGridControl1.TableControl.GroupDropArea.ColWidths(i) = topLeftCellWidth - proposedWidth + emptySpaceWidth
                End If
            End If
        Next
    End Sub

    'To maintain the column width value to 0 after performing any drag and drop operation.
    Private Sub GroupDropArea_ColWidthsChanged(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridRowColSizeChangedEventArgs)
        PivotGridControl1.TableModel.ColWidths(2) = 0

        ''Resize the elements in row grouping bar.
        Dim emptySpaceWidth As Integer = 6
        Dim index As Integer
        For j As Integer = 1 To 2 * (PivotGridControl1.TableControl.PivotRows.Count)
            If j Mod 2 = 0 AndAlso PivotGridControl1.TableControl.RowGroupDropArea IsNot Nothing AndAlso PivotGridControl1.TableControl.RowGroupDropArea.Model IsNot Nothing Then
                index = j / 2
                PivotGridControl1.TableControl.RowGroupDropArea.Model.ColWidths(j) = PivotGridControl1.TableModel.ColWidths(index) - (emptySpaceWidth + emptySpaceWidth / 2)
            End If
        Next

        'Me.GroupBarItems()
    End Sub

    Dim value As String
    Dim cellInfo As PivotCellInfo

    Private Sub TableModel_ColWidthsChanged(ByVal sender As Object, ByVal e As GridRowColSizeChangedEventArgs)
        'Resize the elements in row grouping bar.
        Dim emptySpaceWidth As Integer = 6
        Dim index As Integer
        For j As Integer = 1 To 2 * (PivotGridControl1.TableControl.PivotRows.Count)
            If j Mod 2 = 0 AndAlso PivotGridControl1.TableControl.RowGroupDropArea IsNot Nothing AndAlso PivotGridControl1.TableControl.RowGroupDropArea.Model IsNot Nothing Then
                index = j / 2
                PivotGridControl1.TableControl.RowGroupDropArea.Model.ColWidths(j) = PivotGridControl1.TableModel.ColWidths(index) - (emptySpaceWidth + emptySpaceWidth / 2)
            End If
        Next

        ' Me.GroupBarItems()
    End Sub
End Class